<?php
/*
Plugin Name: cos-html-cache
Plugin URI: http://www.storyday.com
Description: create static html files for wordpress when edit delete or comment a post with OUT ajax comments building in
Version: 2.0
Author: jiangdong
date:2007-03-29
Author URI:http://www.storyday.com
*/
/*
Change log:
2007-06-02:  add custom cookie to fix Chinese charactor problems
2007-06-03:  add page cache function
2007-06-24:  fix js bugs of chinese display
2007-07-25:	  change the cache merchanism
*/

$sm_locale = get_locale();

$sm_mofile = dirname(__FILE__) . "/cosbeta-$sm_locale.mo";
load_textdomain('cosbeta', $sm_mofile);
require_once (ABSPATH."/wp-content/plugins/cos-html-cache/Snoopy.class.php");
include ABSPATH."/wp-content/plugins/cos-html-cache/config.php";

$cossoteurl = get_option('siteurl');
$cossithome = get_option('home');

define('CosSiteUrl',$cossoteurl);
define('CosSiteHome',$cossithome);

if( !function_exists('GetWebContent') ){
   function GetWebContent($uri)  {
	$snoopy = new CosBetaSnoopy;
	$snoopy->fetch( $uri );
	$html = $snoopy->results;
	return $html;
   }
}


if( !function_exists('DelCacheByUrl') ){
	function DelCacheByUrl($url) {
		$url = ABSPATH.str_replace( CosSiteHome,"",$url );	
		$url = str_replace("//","/", $url );
			 if( file_exists( $url )){
				 if( is_dir( $url )) {@unlink( $url."/index.html" );@rmdir($url);}
				 else @unlink( $url );
			 }
	}
}

if( !function_exists('htmlCacheDel') ){
	// create single html	
	function htmlCacheDel($post_ID) {
		if( $post_ID == "" ) return true;
		$uri  = get_permalink($post_ID);
		DelCacheByUrl($uri );	

	}
}
if( !function_exists('htmlCacheDelNb') ){
	// delete nabour posts
	function htmlCacheDelNb($post_ID) {
		if( $post_ID == "" ) return true;

		$uri  = get_permalink($post_ID);
		DelCacheByUrl($uri );	
		global $wpdb;
		 $postRes=$wpdb->get_results("SELECT `ID`  FROM `" . $wpdb->posts . "` WHERE post_status = 'publish'   AND   post_type='post'   AND  ID < ".$post_ID." ORDER BY ID DESC LIMIT 0,1;");		
		$uri1  = get_permalink($postRes[0]->ID);
		DelCacheByUrl($uri1 );	
		  $postRes=$wpdb->get_results("SELECT `ID`  FROM `" . $wpdb->posts . "` WHERE post_status = 'publish'  AND   post_type='post'    AND ID > ".$post_ID."  ORDER BY ID DESC  LIMIT 0,1;");
		  if( $postRes[0]->ID != '' ){
			  $uri2  = get_permalink($postRes[0]->ID);
			  DelCacheByUrl($uri2 );	
		  }

	}
}
//create index.html
if( !function_exists('createIndexHTML') ){
	function createIndexHTML($post_ID){
		if( $post_ID == "" ) return true;
		$contents = GetWebContent( CosSiteUrl."/index.php");
		$contents .= "<!-- create at ".date("Y-m-d H:i:s")." by cos-html-cache 2.0 -->";
		$fp = @fopen(ABSPATH."index.html","w+" );
		if($fp){
		 @flock($fp ,LOCK_EX );
		  // write the file。	
		  fwrite( $fp , $contents );
	      @flock($fp, LOCK_UN);
		  fclose($fp);
		 }
	}
}
if(!function_exists("htmlCacheDel_reg_admin")) {
	/**
	* Add the options page in the admin menu
	*/
	function htmlCacheDel_reg_admin() {
		if (function_exists('add_options_page')) {
			add_options_page('html-cache-creator', 'CosHtmlCache',8, basename(__FILE__), 'cosHtmlOption');	
			//add_options_page($page_title, $menu_title, $access_level, $file).
		}
	}
}
add_action('admin_menu', 'htmlCacheDel_reg_admin');
/*
*/
if(!function_exists("cosHtmlOption")) {
function cosHtmlOption(){
	do_cos_html_cache_action();
?>
	<div class="wrap" style="padding:10px 0 0 0;text-align:center">
	<form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">	
	<p>
	<?php _e("Click the button bellow to delete all the html cache files","cosbeta");?></p>
	<p><?php _e("Note:this will Not  delete data from your databases","cosbeta");?></p>
	<p><?php _e("If you want to rebuild all cache files, you should delete them first,and then the cache files will be built when post or page first visited","cosbeta");?></p>
	<p><input type="submit" value="<?php _e("Delete Html Cache files","cosbeta");?>" id="htmlCacheDelbt" name="htmlCacheDelbt" onClick="return checkcacheinput(); " />
	</form>

	<SCRIPT LANGUAGE="JavaScript">
	<!--
		function checkcacheinput(){
		document.getElementById('htmlCacheDelbt').value = 'Please Wait...';
		return true;
	}
	//-->
	</SCRIPT>
<?php
	}
}
/*
end of get url
*/
// deal with rebuild or delete
function do_cos_html_cache_action(){
	if( !empty($_POST['htmlCacheDelbt']) ){
		global $wpdb;
		 $postRes=$wpdb->get_results("SELECT `ID`  FROM `" . $wpdb->posts . "` WHERE post_status = 'publish' AND ( post_type='post' OR  post_type='page' )  ORDER BY post_modified DESC ");	

		  foreach($postRes as $post) {
				 DelCacheByUrl(get_permalink($post->ID));
			   }
			$msg = __('HTML Caches were deleted successfully');
		
	}
	 if($msg)
   echo '<div class="updated"><strong><p>'.$msg.'</p></div>';
}

/*
 * with ajax comments
 */

if ( !function_exists("cos_comments_js") ){
	function cos_comments_js($postID){
		?>
		 <div id="cos_login_admin_hint"></div>
		   <script language="JavaScript" type="text/javascript" src="<?php echo CosSiteHome;?>/wp-content/plugins/cos-html-cache/common.js"></script>
		   <script language="JavaScript" type="text/javascript">
		   //<![CDATA[ 		  
		    function setCommForm(){
				var wordpressuser_cookie = "<?php echo 'wordpressuser_'.COOKIEHASH;?>";
				var admin_user_cookie = readCosBetaCookie(wordpressuser_cookie);
				if( admin_user_cookie.length > 2){
					if(document.getElementById('cos_login_admin_hint') !=null ){
						document.getElementById('cos_login_admin_hint').innerHTML = " <div style='background:green;color:#fff;font-weight:bold;border:1px solid #565;padding:4px;'><?php _e("You have already logged in,just leave your comment","cosbeta");?></div>";
						if(document.getElementById('author')!=null){
							document.getElementById('author').value= admin_user_cookie;
							document.getElementById('author').style.display = 'none';
						}
						if(document.getElementById('email')!=null){
							document.getElementById('email').value= 'no-need@no-need.com';
							document.getElementById('email').style.display = 'none';
						}
						if(document.getElementById('url')!=null){
							document.getElementById('url').style.display = 'none';
						}
					}
				}else{
					var custom_author_cookie = "<?php echo 'comment_author_costom_'.COOKIEHASH;?>";
					var author_cookie = "<?php echo 'comment_author_'.COOKIEHASH;?>";
					var email_cookie = "<?php echo 'comment_author_email_'.COOKIEHASH;?>";
					var url_cookie = "<?php echo 'comment_author_url_'.COOKIEHASH;?>";
					if(document.getElementById('author')!=null){
						document.getElementById('author').value= readCosBetaCookie(author_cookie);
						if( readCosBetaCookie(custom_author_cookie).length > 1 ){
							document.getElementById('author').value= readCosBetaCookie(custom_author_cookie);
						}
					}
					if(document.getElementById('email')!=null)
					document.getElementById('email').value= readCosBetaCookie(email_cookie);
					if(document.getElementById('url')!=null)
					document.getElementById('url').value= readCosBetaCookie(url_cookie);
					}
	
				}
			setCommForm();
		   //]]>
		   </script>
		  
	<?php
		}
}

function CosInitCache($postID){
	if( $_GET['CosBetaSpider'] == 'true') return false;

	if( !is_single() &&  !is_page()) return true;

			if( is_single() ){
			   $get_var = "?CosBetaSpider=true&p=".$postID;
		   }else{
			   $get_var = "?CosBetaSpider=true&page_id=".$postID;
		   }
			$perlink = get_permalink($postID);
			$uri =  base64_encode($perlink);
			$url = base64_encode($perlink."?CosBetaSpider=true");
			$url = base64_encode(CosSiteHome."/index.php".$get_var);
		    $home = base64_encode(CosSiteHome);

			$get_var .= "&CosPassWord=".base64_encode(CosPassWord)."&CosSiteHome=".$home."&uri=".$uri."&ABSPATH=".base64_encode(ABSPATH);
			$src= CosSiteHome."/wp-content/plugins/cos-html-cache/cosbeta.php".$get_var;
			GetWebContent($src);

}

add_filter('comment_form','CosInitCache'); 

add_action('comment_form', 'cos_comments_js');

/* end of ajaxcomments*/

add_action('publish_post', 'createIndexHTML');
add_action('publish_post', 'htmlCacheDelNb');

add_action('delete_post', 'createIndexHTML');
add_action('delete_post', 'htmlCacheDelNb');

//if comments add
add_action('edit_post', 'htmlCacheDel');
add_action('edit_post', 'createIndexHTML');

?>